on startMovie
  global gPathDelim, gIsPC, debug
  repeat with i = 152 to 155
    set the loop of cast i to 1
  end repeat
  set gScary to 0
  if the machineType = 256 then
    set gIsPC to 1
    set gPathDelim to "\"
  else
    set gIsPC to 0
    set gPathDelim to ":"
    envTest()
    openXLib(the pathName & "XTERNS" & gPathDelim & "JOHNNY.XOBJ")
  end if
  set debug to 1
end

on stopMovie
  global gPathDelim, gFixpal, gIsPC, gScary, gf
  if not gIsPC then
    closeXLib(the pathName & "XTERNS" & gPathDelim & "JOHNNY.XOBJ")
    if gScary then
      gf(mdispose)
      closeXLib(the pathName & "XTERNS" & gPathDelim & "GammaFade XObj")
    end if
    closeXLib()
  end if
  repeat with i = 152 to 155
    set the loop of cast i to 1
  end repeat
end

on init
  global gBody, gHead, gBlnk, gLastUpdate, gCharScreenFlag, gCurrChar, gMatchScreenFlag, gfMatchCst, gTotalMatchCst, gMatchCurrList, gMatchAvailList, gMatchHotList, gSlotList, gMatchSelect, gActiveList
  set gCharBody to 30
  set gCharHead to 31
  if the machineType = 256 then
    set the volume of sound 1 to 255
  else
    set the volume of sound 1 to 64
  end if
  set the volume of sound 2 to 256
  set gBlnk to the number of cast "blank"
  resetCursor()
  set gLastUpdate to the timer
  set gfMatchCst to 200
  set gTotalMatchCst to 80
  set gMatchCurrList to []
  set gMatchAvailList to []
  set gMatchHotList to []
  set gSlotList to [10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25]
  set gMatchSelect to [0, 0, 0]
  set gCharScreenFlag to 0
  set gCurrChar to 0
  set gMatchScreenFlag to 0
  repeat with i = 1 to gTotalMatchCst
    add(gMatchAvailList, i + gfMatchCst - 1)
  end repeat
  set gActiveList to []
  set the text of field "MatchScore" to "0"
  set the text of field "ScrambleScore" to "0"
  set the text of field "TriviaScore" to "0"
  set the text of field "HangScore" to "0"
  CheesyWipe()
  go("charselect")
end

on UpdateRolls
  global gActiveCast, aButtList
  set mCast to the mouseCast
  if getPos(gActiveCast, mCast) then
    RollButt(getAt(aButtList, getPos(gActiveCast, mCast)))
  end if
  updateStage()
end

on OldGoFrame fName
  global gGoFrame, gScary
  set gGoFrame to fName
  repeat with i = 1 to 48
    puppetSprite(i, 0)
  end repeat
  if gScary then
    fadeOut()
    go(fName)
    fadeIn()
  else
    go(marker(1))
  end if
end

on SlowFadeIn
  global gf
  set stepFade to 1
  set i to 1
  repeat while i <= 100
    gf(mFade, i)
    set i to i + stepFade
  end repeat
  gf(mFade, 100)
end

on fadeIn
  global gf
  set stepFade to 3
  set i to 1
  repeat while i <= 100
    gf(mFade, i)
    set i to i + stepFade
  end repeat
  gf(mFade, 100)
end

on fadeOut
  global gf
  set stepFade to 3
  set i to 100
  repeat while i >= 1
    gf(mFade, i)
    set i to i - stepFade
  end repeat
  gf(mFade, 1)
end

on CheesyWipe
  puppetTransition(3, 2, 8)
end

on HDYFTalk charID, spchRate, fID, soundList, fFaceList
  global gBlnk, gPathDelim
  set the castNum of sprite 17 to 852 + charID
  set fCst to 862
  set chan to 18
  set fCst to fCst + ((charID - 1) * 11) + 1
  preLoadCast(fCst, fCst + 9)
  set the type of sprite chan to 1
  set the castNum of sprite chan to fCst
  DissolveTransition()
  updateStage()
  wait(30)
  set holdVol to the volume of sound 2
  sfd(2, 30, 50)
  set RepCount to count(soundList)
  repeat with increment = 1 to RepCount
    set sndName to getAt(soundList, increment)
    sound playFile 1, the pathName & fID & gPathDelim & sndName
    set theTime to the timer + getAt(fFaceList, increment)
    set the castNum of sprite chan to fCst + 3 + getPropAt(fFaceList, increment)
    UStage(theTime)
    repeat while soundBusy(1)
      set theTime to the timer + Randomize(spchRate, 3)
      set the castNum of sprite chan to fCst + 3 + random(6)
      UStage(theTime)
      if the mouseDown then
        set exitFlag to 1
        exit repeat
      end if
    end repeat
    if exitFlag or the mouseDown then
      exit repeat
    end if
    set the castNum of sprite chan to fCst
    updateStage()
    if (RepCount > 1) and (increment <> RepCount) then
      set theTime to the timer + 30
      set the castNum of sprite chan to fCst + random(3)
      UStage(theTime)
      set theTime to the timer + 30
      set the castNum of sprite chan to fCst
      UStage(theTime)
    end if
  end repeat
  sound stop 1
  sfd(2, 30, holdVol)
  wait(30)
  set fCst to 965
  puppetSnd("FPayoff" & string(charID))
  set the castNum of sprite 18 to fCst + charID
  DissolveTransition()
  updateStage()
  wait(4 * 60)
  set the castNum of sprite 17 to gBlnk
  set the castNum of sprite 18 to gBlnk
  DissolveTransition()
  updateStage()
end

on setPuppets theList, state
  repeat with theChan in theList
    puppetSprite(theChan, state)
    set the stretch of sprite theChan to 0
    set the type of sprite theChan to 1
  end repeat
end

on puppetSnd sound
  if sound <> EMPTY then
    puppetSound(sound)
  end if
end

on WaitUntilQuietOrClick chan
  repeat while soundBusy(chan)
    if the mouseDown then
      exit repeat
    end if
  end repeat
end

on button downSnd, upSound, doScript
  set chan to the clickOn
  set the stretch of sprite chan to 0
  set UpCast to the castNum of sprite chan
  set downCast to UpCast + 1
  set the castNum of sprite chan to downCast
  puppetSound(downSnd)
  updateStage()
  repeat while soundBusy(1)
  end repeat
  repeat while the mouseDown
    if rollOver(chan) then
      if the castNum of sprite chan = UpCast then
        set the castNum of sprite chan to downCast
        puppetSound(downSnd)
      end if
    else
      if the castNum of sprite chan = downCast then
        set the castNum of sprite chan to UpCast
        puppetSound(upSound)
      end if
    end if
    updateStage()
  end repeat
  repeat while soundBusy(1)
  end repeat
  if the castNum of sprite chan = downCast then
    set the castNum of sprite chan to UpCast
    puppetSound(upSound)
    updateStage()
    repeat while soundBusy(1)
    end repeat
    do(doScript)
  end if
end

on Randomize center, range
  return center + random(range) - (range / 2)
end

on wait waitTicks
  set theTime to the timer + waitTicks
  repeat while the timer < theTime
  end repeat
end

on SetSprite spriteNum, cNum
  set the castNum of sprite spriteNum to cNum
end

on UStage theTime
  updateStage()
  repeat while the timer < theTime
  end repeat
end

on resetCursor
  cursor(-1)
end

on closeRearWindow
  global rwObj
  if objectp(rwObj) then
    rwObj(mdispose)
  end if
end

on playSound sndName
  global gPathDelim
  sound playFile 2, the pathName & "AUDIO" & gPathDelim & sndName
end

on sfo chan, fadeOutTime
  set startLevel to the volume of sound chan
  set theEndTime to the timer + fadeOutTime
  repeat while the timer <= theEndTime
    set theTimeLeft to theEndTime - the timer
    set thePercent to theTimeLeft / (fadeOutTime * 1.0)
    set the volume of sound chan to integer(startLevel * thePercent)
  end repeat
  set the volume of sound chan to 0
  sound stop chan
  if chan = 1 then
    puppetSound(0)
  end if
  set the volume of sound chan to startLevel
end

on sfd chan, fadeTime, endLevel
  set startLevel to the volume of sound chan
  set delta to startLevel - endLevel
  set theEndTime to the timer + fadeTime
  repeat while the timer <= theEndTime
    set theTimeLeft to theEndTime - the timer
    set thePercent to theTimeLeft / (fadeTime * 1.0)
    set the volume of sound chan to endLevel + integer(delta * thePercent)
  end repeat
  set the volume of sound chan to endLevel
end

on DissolveTransition
  global gIsPC
  if not gIsPC then
    puppetTransition(51, 3)
  else
    puppetTransition(51, 3)
  end if
end

on FLUSH
  global gFlush, gIsPC
  if not gIsPC then
    set gFlush to Johnny(mnew)
    gFlush(mFlush)
    gFlush(mdispose)
  else
    PCFlush()
  end if
end

on PCFlush
  global oldkeyD, oldMd, oldMu, flushActive
  put "flushcalleD"
  if flushActive then
    exit
  end if
  set oldMd to the mouseDownScript
  set oldMu to the mouseUpScript
  set the mouseDownScript to "dontPassEvent"
  set the mouseUpScript to "dontPassEvent"
  set the timeoutLength to 5
  set the timeoutScript to "ResetEvents"
  set flushActive to 1
end

on ResetEvents
  global oldkeyD, oldMd, oldMu, flushActive
  if the machineType <> 256 then
    exit
  end if
  if oldMd = "DontPassEvent" then
    set the mouseDownScript to EMPTY
  else
    set the mouseDownScript to EMPTY
  end if
  if oldMu = "DontPassEvent" then
    set the mouseUpScript to EMPTY
  else
    set the mouseUpScript to EMPTY
  end if
  set the timeoutScript to EMPTY
  set flushActive to 0
end

on scramblesort sourceList
  set baseList to value(string(sourceList))
  set listCnt to count(baseList)
  set sortList to []
  repeat with i = 1 to listCnt
    set idx to random(count(baseList))
    add(sortList, getAt(baseList, idx))
    deleteAt(baseList, idx)
  end repeat
  return sortList
end

on makeIdentityList size
  set newList to []
  repeat with i = 1 to size
    add(newList, i)
  end repeat
  return newList
end

on GetOneDelete theList
  set idx to random(count(theList))
  set curItem to getAt(theList, idx)
  deleteAt(theList, idx)
  return curItem
end

on envTest
  global gPathDelim, gIsPC
  if not gIsPC then
    if the colorQD = 0 then
      alert("Rodney Rubber requires a color QuickDraw Mac.")
      quit()
    end if
    if the soundLevel = 0 then
      alert("The sound level must be set above 0 for Rodney Rubber to work. The sound level is being set to 5.")
      set the soundLevel to 5
    end if
  else
  end if
end

on DebugPrint stmt
  global debug
  set debug to 0
  if not debug then
    exit
  end if
  put stmt
end

on GoVideo
  goFrame(marker(1))
end

on PrepareForVideo
  global gZoom, gBlnk, gMovieDur
  set gZoom to 0
  unLoad()
  set the puppet of sprite 48 to 1
  set the castNum of sprite 48 to gBlnk + 1 + random(4)
  updateStage()
  set gMovieDur to the duration of cast the castNum of sprite 48
  set the volume of sprite 48 to 255
  set the movieRate of sprite 48 to 1
end

on JustQuit
  goFrame("quit")
end

on GoFrameVideo vfname
  global lastPlace
  set lastPlace to marker(0)
  goFrame(vfname)
end

on Hide
  global lastPlace
  set lastPlace to marker(0)
  goFrame("HIDE")
end

on RewindVideo
  if not (the mouseDown) then
    set the movieTime of sprite 48 to the movieTime of sprite 48 - 120
    set the movieRate of sprite 48 to 1
  else
    set the volume of sprite 48 to 0
    set the movieRate of sprite 48 to -3
    repeat while the mouseDown
      updateStage()
    end repeat
    set the volume of sprite 48 to 255
    set the movieRate of sprite 48 to 1
  end if
end

on StopVideo
  set the movieRate of sprite 48 to 0
end

on FastForwardVideo
  if not (the mouseDown) then
    set the movieTime of sprite 48 to the movieTime of sprite 48 + 120
    set the movieRate of sprite 48 to 1
  else
    set the volume of sprite 48 to 0
    set the movieRate of sprite 48 to 3
    repeat while the mouseDown
      updateStage()
    end repeat
    set the volume of sprite 48 to 255
    set the movieRate of sprite 48 to 1
  end if
end

on PlayVideo
  set the movieRate of sprite 48 to 1
end

on PlaySndAndWait sndName
  playSound(sndName)
  repeat while soundBusy(2)
    if the mouseDown then
      exit repeat
    end if
  end repeat
end

on ZoomVideo
  global gZoom
  set gZoom to 1
  set the locH of sprite 48 to 320
  set the locV of sprite 48 to 240
  set the width of sprite 48 to 640
  set the height of sprite 48 to 480
  updateStage()
end

on UnZoomVideo
  global gZoom
  set gZoom to 0
  set the visible of sprite 48 to 0
  set the locH of sprite 48 to 400
  set the locV of sprite 48 to 168
  set the width of sprite 48 to 320
  set the height of sprite 48 to 240
  updateStage()
  set the visible of sprite 48 to 1
  updateStage()
end

on LoopVideo
  set the loop of cast the castNum of sprite 48 to 1
end

on UnLoopVideo
  set the loop of cast the castNum of sprite 48 to 0
end

on KillVideo
  set the loop of cast the castNum of sprite 48 to 0
  set the movieRate of sprite 48 to 0
  set the visible of sprite 48 to 0
  updateStage()
  set the visible of sprite 48 to 1
end
